Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4345)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4340 2019-12-16 08:17:03Z Giersch
 ! Topography closed channel flow with symmetric boundaries implemented
 ! 
@@ -2353,5 +2357,5 @@
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
-               nzt, topo_top_ind, wall_flags_static_0
+               nzt, topo_top_ind, wall_flags_static_0, wall_flags_total_0
 
     USE kinds
@@ -2407,20 +2411,35 @@
 
     CALL exchange_horiz_int( wall_flags_static_0, nys, nyn, nxl, nxr, nzt, nbgp )
+
 !
 !-- Set outer array for scalars to mask near-surface grid points. Note, on 
 !-- basis of flag 24 futher flags will be derived which are used to control
 !-- production of subgrid TKE production near walls. 
+    
+    ALLOCATE( wall_flags_total_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    wall_flags_total_0 = 0
+                                    
     DO i = nxl, nxr
        DO j = nys, nyn
           DO k = nzb, nzt+1
-             IF ( BTEST( wall_flags_static_0(k,j-1,i), 0 )    .AND.                   &
-                  BTEST( wall_flags_static_0(k,j+1,i), 0 )    .AND.                   &
-                  BTEST( wall_flags_static_0(k,j,i-1), 0 )    .AND.                   &
-                  BTEST( wall_flags_static_0(k,j,i+1), 0 )    .AND.                   &
-                  BTEST( wall_flags_static_0(k,j-1,i-1), 0 )  .AND.                   &
-                  BTEST( wall_flags_static_0(k,j+1,i-1), 0 )  .AND.                   &
-                  BTEST( wall_flags_static_0(k,j-1,i+1), 0 )  .AND.                   &
-                  BTEST( wall_flags_static_0(k,j+1,i+1), 0 ) )                        &
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 24 )
+             wall_flags_total_0(k,j,i) = IOR( wall_flags_total_0(k,j,i), wall_flags_static_0(k,j,i) )
+          ENDDO
+       ENDDO
+    ENDDO
+    
+    CALL exchange_horiz_int( wall_flags_total_0, nys, nyn, nxl, nxr, nzt, nbgp )
+    
+    DO i = nxl, nxr
+       DO j = nys, nyn
+          DO k = nzb, nzt+1
+             IF ( BTEST( wall_flags_total_0(k,j-1,i), 0 )    .AND.                   &
+                  BTEST( wall_flags_total_0(k,j+1,i), 0 )    .AND.                   &
+                  BTEST( wall_flags_total_0(k,j,i-1), 0 )    .AND.                   &
+                  BTEST( wall_flags_total_0(k,j,i+1), 0 )    .AND.                   &
+                  BTEST( wall_flags_total_0(k,j-1,i-1), 0 )  .AND.                   &
+                  BTEST( wall_flags_total_0(k,j+1,i-1), 0 )  .AND.                   &
+                  BTEST( wall_flags_total_0(k,j-1,i+1), 0 )  .AND.                   &
+                  BTEST( wall_flags_total_0(k,j+1,i+1), 0 ) )                        &
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 24 )
           ENDDO
        ENDDO
@@ -2446,8 +2465,8 @@
 !--          effect on the flow is negligible. 
              IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-                IF ( BTEST( wall_flags_static_0(k,j,i), 0 ) )                         &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 8 )
+                IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )                         &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 8 )
              ELSE
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 8 )
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 8 )
              ENDIF
 
@@ -2456,7 +2475,7 @@
 !--       Special flag to control vertical diffusion at model top - former 
 !--       nzt_diff
-          wall_flags_static_0(:,j,i) = IBSET( wall_flags_static_0(:,j,i), 9 )
+          wall_flags_total_0(:,j,i) = IBSET( wall_flags_total_0(:,j,i), 9 )
           IF ( use_top_fluxes )                                                &
-             wall_flags_static_0(nzt+1,j,i) = IBCLR( wall_flags_static_0(nzt+1,j,i), 9 )
+             wall_flags_total_0(nzt+1,j,i) = IBCLR( wall_flags_total_0(nzt+1,j,i), 9 )
 
 
@@ -2467,8 +2486,8 @@
 !--          topography, as well as initialize u with zero one grid point outside
 !--          of topography.
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 1 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k,j,i),   1 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k+1,j,i), 1 ) )                          &
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 20 )
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 1 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k,j,i),   1 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k+1,j,i), 1 ) )                          &
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 20 )
 !
 !--          Special flag on v grid, former nzb_v_inner + 1, required   
@@ -2476,26 +2495,26 @@
 !--          topography, as well as initialize v with zero one grid point outside
 !--          of topography.
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 2 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k,j,i),   2 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k+1,j,i), 2 ) )                          &
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 21 )
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 2 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k,j,i),   2 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k+1,j,i), 2 ) )                          &
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 21 )
 !
 !--          Special flag on scalar grid, former nzb_s_inner+1. Used for 
 !--          lpm_sgs_tke
-             IF ( BTEST( wall_flags_static_0(k,j,i),   0 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k-1,j,i), 0 )  .AND.                     &
-                  BTEST( wall_flags_static_0(k+1,j,i), 0 ) )                          &
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 25 )
+             IF ( BTEST( wall_flags_total_0(k,j,i),   0 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k-1,j,i), 0 )  .AND.                     &
+                  BTEST( wall_flags_total_0(k+1,j,i), 0 ) )                          &
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 25 )
 !
 !--          Special flag on scalar grid, nzb_diff_s_outer - 1, required in 
 !--          in production_e
              IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-                IF ( BTEST( wall_flags_static_0(k,j,i),   24 )  .AND.                 &
-                     BTEST( wall_flags_static_0(k-1,j,i), 24 )  .AND.                 &
-                     BTEST( wall_flags_static_0(k+1,j,i), 0 ) )                       &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 29 )
+                IF ( BTEST( wall_flags_total_0(k,j,i),   24 )  .AND.                 &
+                     BTEST( wall_flags_total_0(k-1,j,i), 24 )  .AND.                 &
+                     BTEST( wall_flags_total_0(k+1,j,i), 0 ) )                       &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 29 )
              ELSE
-                IF ( BTEST( wall_flags_static_0(k,j,i), 0 ) )                         &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 29 )
+                IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )                         &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 29 )
              ENDIF
 !
@@ -2503,11 +2522,11 @@
 !--          in production_e
              IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-                IF ( BTEST( wall_flags_static_0(k,j,i),   0 )  .AND.                  &
-                     BTEST( wall_flags_static_0(k-1,j,i), 0 )  .AND.                  &
-                     BTEST( wall_flags_static_0(k+1,j,i), 0 ) )                       &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 30 )
+                IF ( BTEST( wall_flags_total_0(k,j,i),   0 )  .AND.                  &
+                     BTEST( wall_flags_total_0(k-1,j,i), 0 )  .AND.                  &
+                     BTEST( wall_flags_total_0(k+1,j,i), 0 ) )                       &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 30 )
              ELSE
-                IF ( BTEST( wall_flags_static_0(k,j,i), 0 ) )                         &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 30 )
+                IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )                         &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 30 )
              ENDIF
           ENDDO
@@ -2517,22 +2536,22 @@
 !
 !--          Scalar grid
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 0 )  .AND.                     &
-            .NOT. BTEST( wall_flags_static_0(k,j,i), 0   ) )                          & 
-                 wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 13 ) 
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 0 )  .AND.                     &
+            .NOT. BTEST( wall_flags_total_0(k,j,i), 0   ) )                          & 
+                 wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 13 ) 
 !
 !--          Downward facing wall on u grid
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 1 )  .AND.                     &
-            .NOT. BTEST( wall_flags_static_0(k,j,i), 1   ) )                          & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 15 )
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 1 )  .AND.                     &
+            .NOT. BTEST( wall_flags_total_0(k,j,i), 1   ) )                          & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 15 )
 !
 !--          Downward facing wall on v grid
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 2 )  .AND.                     &
-            .NOT. BTEST( wall_flags_static_0(k,j,i), 2   ) )                          & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 17 )
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 2 )  .AND.                     &
+            .NOT. BTEST( wall_flags_total_0(k,j,i), 2   ) )                          & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 17 )
 !
 !--          Downward facing wall on w grid
-             IF ( BTEST( wall_flags_static_0(k-1,j,i), 3 )  .AND.                     &
-            .NOT. BTEST( wall_flags_static_0(k,j,i), 3 ) )                            & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 19 )
+             IF ( BTEST( wall_flags_total_0(k-1,j,i), 3 )  .AND.                     &
+            .NOT. BTEST( wall_flags_total_0(k,j,i), 3 ) )                            & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 19 )
           ENDDO
 !
@@ -2541,46 +2560,46 @@
 !
 !--          Upward facing wall on scalar grid
-             IF ( .NOT. BTEST( wall_flags_static_0(k,j,i),   0 )  .AND.               &
-                        BTEST( wall_flags_static_0(k+1,j,i), 0 ) )                    & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 12 )
+             IF ( .NOT. BTEST( wall_flags_total_0(k,j,i),   0 )  .AND.               &
+                        BTEST( wall_flags_total_0(k+1,j,i), 0 ) )                    & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 12 )
 !
 !--          Upward facing wall on u grid
-             IF ( .NOT. BTEST( wall_flags_static_0(k,j,i),   1 )  .AND.               &
-                        BTEST( wall_flags_static_0(k+1,j,i), 1 ) )                    & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 14 )
+             IF ( .NOT. BTEST( wall_flags_total_0(k,j,i),   1 )  .AND.               &
+                        BTEST( wall_flags_total_0(k+1,j,i), 1 ) )                    & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 14 )
 
 !   
 !--          Upward facing wall on v grid
-             IF ( .NOT. BTEST( wall_flags_static_0(k,j,i),   2 )  .AND.               &
-                        BTEST( wall_flags_static_0(k+1,j,i), 2 ) )                    & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 16 )
+             IF ( .NOT. BTEST( wall_flags_total_0(k,j,i),   2 )  .AND.               &
+                        BTEST( wall_flags_total_0(k+1,j,i), 2 ) )                    & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 16 )
    
 !
 !--          Upward facing wall on w grid
-             IF ( .NOT. BTEST( wall_flags_static_0(k,j,i),   3 )  .AND.               &
-                        BTEST( wall_flags_static_0(k+1,j,i), 3 ) )                    & 
-                wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 18 )
+             IF ( .NOT. BTEST( wall_flags_total_0(k,j,i),   3 )  .AND.               &
+                        BTEST( wall_flags_total_0(k+1,j,i), 3 ) )                    & 
+                wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 18 )
 !
 !--          Special flag on scalar grid, former nzb_s_inner
-             IF ( BTEST( wall_flags_static_0(k,j,i), 0 )  .OR.                        &
-                  BTEST( wall_flags_static_0(k,j,i), 12 ) .OR.                        &
-                  BTEST( wall_flags_static_0(k,j,i), 13 ) )                           &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 22 )
+             IF ( BTEST( wall_flags_total_0(k,j,i), 0 )  .OR.                        &
+                  BTEST( wall_flags_total_0(k,j,i), 12 ) .OR.                        &
+                  BTEST( wall_flags_total_0(k,j,i), 13 ) )                           &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 22 )
 !
 !--          Special flag on scalar grid, nzb_diff_s_inner - 1, required for 
 !--          flow_statistics
              IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
-                IF ( BTEST( wall_flags_static_0(k,j,i),   0 )  .AND.                  &
-                     BTEST( wall_flags_static_0(k+1,j,i), 0 ) )                       &
-                  wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 23 )
+                IF ( BTEST( wall_flags_total_0(k,j,i),   0 )  .AND.                  &
+                     BTEST( wall_flags_total_0(k+1,j,i), 0 ) )                       &
+                  wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 23 )
              ELSE
-                IF ( BTEST( wall_flags_static_0(k,j,i), 22 ) )                        &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 23 )
+                IF ( BTEST( wall_flags_total_0(k,j,i), 22 ) )                        &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 23 )
              ENDIF
    
 
           ENDDO
-          wall_flags_static_0(nzt+1,j,i) = IBSET( wall_flags_static_0(nzt+1,j,i), 22 )
-          wall_flags_static_0(nzt+1,j,i) = IBSET( wall_flags_static_0(nzt+1,j,i), 23 )
+          wall_flags_total_0(nzt+1,j,i) = IBSET( wall_flags_total_0(nzt+1,j,i), 22 )
+          wall_flags_total_0(nzt+1,j,i) = IBSET( wall_flags_total_0(nzt+1,j,i), 23 )
 !
 !--       Set flags indicating that topography is close by in horizontal 
@@ -2593,19 +2612,19 @@
           IF ( scalar_advec == 'ws-scheme' )  THEN
              DO k = nzb, nzt
-                IF ( BTEST( wall_flags_static_0(k,j,i), 0 )  .AND. (                   &
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i-1), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i-2), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i-3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i+1), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i+2), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3:j+3,i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-1,i-3:i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-2,i-3:i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j-3,i-3:i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j+1,i-3:i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j+2,i-3:i+3), 0 ) )  .OR.&
-                     ANY( .NOT. BTEST( wall_flags_static_0(k,j+3,i-3:i+3), 0 ) )      &
-                                                            ) )                &
-                   wall_flags_static_0(k,j,i) = IBSET( wall_flags_static_0(k,j,i), 31 )
+                IF ( BTEST( wall_flags_total_0(k,j,i), 0 )  .AND. (                  &
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i-1), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i-2), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i-3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i+1), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i+2), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3:j+3,i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-1,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-2,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j-3,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j+1,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j+2,i-3:i+3), 0 ) )  .OR.&
+                     ANY( .NOT. BTEST( wall_flags_total_0(k,j+3,i-3:i+3), 0 ) )      &
+                                                            ) )                      &
+                   wall_flags_total_0(k,j,i) = IBSET( wall_flags_total_0(k,j,i), 31 )
                      
              ENDDO
@@ -2656,7 +2675,17 @@
        ENDDO
     ENDDO
+    
+    CALL exchange_horiz_int( wall_flags_static_0, nys, nyn, nxl, nxr, nzt, nbgp )
+    
+    DO i = nxl, nxr
+       DO j = nys, nyn
+          DO k = nzb, nzt+1
+             wall_flags_total_0(k,j,i) = IOR( wall_flags_total_0(k,j,i), wall_flags_static_0(k,j,i) )
+          ENDDO
+       ENDDO
+    ENDDO
 !
 !-- Exchange ghost points for wall flags
-    CALL exchange_horiz_int( wall_flags_static_0, nys, nyn, nxl, nxr, nzt, nbgp )
+    CALL exchange_horiz_int( wall_flags_total_0, nys, nyn, nxl, nxr, nzt, nbgp )
 !
 !-- Set boundary conditions also for flags. Can be interpreted as Neumann
@@ -2665,10 +2694,10 @@
        IF ( nys == 0  )  THEN
           DO  i = 1, nbgp     
-             wall_flags_static_0(:,nys-i,:)   = wall_flags_static_0(:,nys,:)
+             wall_flags_total_0(:,nys-i,:)   = wall_flags_total_0(:,nys,:)
           ENDDO
        ENDIF
        IF ( nyn == ny )  THEN
           DO  i = 1, nbgp  
-             wall_flags_static_0(:,nyn+i,:) = wall_flags_static_0(:,nyn,:)
+             wall_flags_total_0(:,nyn+i,:) = wall_flags_total_0(:,nyn,:)
           ENDDO
        ENDIF
@@ -2677,10 +2706,10 @@
        IF ( nxl == 0  )  THEN
           DO  i = 1, nbgp   
-             wall_flags_static_0(:,:,nxl-i)   = wall_flags_static_0(:,:,nxl)
+             wall_flags_total_0(:,:,nxl-i)   = wall_flags_total_0(:,:,nxl)
           ENDDO
        ENDIF
        IF ( nxr == nx )  THEN 
           DO  i = 1, nbgp   
-             wall_flags_static_0(:,:,nxr+i) = wall_flags_static_0(:,:,nxr)     
+             wall_flags_total_0(:,:,nxr+i) = wall_flags_total_0(:,:,nxr)     
           ENDDO
        ENDIF      
@@ -2695,5 +2724,5 @@
     topo_top_ind(:,:,0) = MAXLOC(                                              &
                                   MERGE( 1, 0,                                 &
-                                          BTEST( wall_flags_static_0(:,:,:), ibit )   &
+                                    BTEST( wall_flags_total_0(:,:,:), ibit )   &
                                        ), DIM = 1                              &
                                 ) - 1 
@@ -2703,5 +2732,5 @@
     topo_top_ind(:,:,1) = MAXLOC(                                              &
                                   MERGE( 1, 0,                                 &
-                                          BTEST( wall_flags_static_0(:,:,:), ibit )   &
+                                    BTEST( wall_flags_total_0(:,:,:), ibit )   &
                                        ), DIM = 1                              &
                                 ) - 1 
@@ -2711,5 +2740,5 @@
     topo_top_ind(:,:,2) = MAXLOC(                                              &
                                   MERGE( 1, 0,                                 &
-                                          BTEST( wall_flags_static_0(:,:,:), ibit )   &
+                                    BTEST( wall_flags_total_0(:,:,:), ibit )   &
                                        ), DIM = 1                              &
                                 ) - 1 
@@ -2719,5 +2748,5 @@
     topo_top_ind(:,:,3) = MAXLOC(                                              &
                                   MERGE( 1, 0,                                 &
-                                          BTEST( wall_flags_static_0(:,:,:), ibit )   &
+                                    BTEST( wall_flags_total_0(:,:,:), ibit )   &
                                        ), DIM = 1                              &
                                 ) - 1 
@@ -2727,8 +2756,8 @@
     topo_top_ind(:,:,4) = MAXLOC(                                              &
                                   MERGE( 1, 0,                                 &
-                                          BTEST( wall_flags_static_0(:,:,:), ibit )   &
+                                    BTEST( wall_flags_total_0(:,:,:), ibit )   &
                                        ), DIM = 1                              &
                                 ) - 1                            
-
+        
  END SUBROUTINE set_topo_flags
 
Index: /palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 4345)
+++ /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
 ! 
@@ -53,5 +57,5 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nzb, nzt, wall_flags_static_0
+        ONLY:  nbgp, nx, nxl, nxr, ny, nyn, nys, nzb, nzt, wall_flags_total_0
 
     USE kinds
@@ -96,5 +100,5 @@
 !
 !--             Predetermine flag to mask topography
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
                 x = ( i - ic ) * dx
@@ -129,5 +133,5 @@
 !
 !--             Predetermine flag to mask topography
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
                 pt(k,j,i) = pt(k,j,i) +                                        &
